#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

int hex(char h);
int hex2(char *h);

const char * debugger="../KCPSM/package/PSMDEBUG.EXE";
const int mem_out_width=4;  //number of bytes per line in output

int main(int argc,char *argv[])
{
  char memval[]="00\r\n";  //used for sending memory values to debugger
  const int cr_len=2;

  FILE *m;
  char mem[513];
  char line[600],c;
  int i,addr=0,high_mem=0;

  for (i=0;i<512;i++)
    mem[i]='0';

  if (argc<=1)
    {
      printf("Usage: memdebug <filename.coe> [memory in file] [memory out file]\n");
      return -1;
    }

  if (argc>2)
    m=fopen(argv[2],"r");
  else
    m=fopen("mem.in","r");
  i=0;
  while (!feof(m) && i<512)
    {
      mem[i]=fgetc(m);
      if ((mem[i]>='0' && mem[i]<='9') ||
	  (mem[i]>='a' && mem[i]<='f') ||
	  (mem[i]>='A' && mem[i]<='F'))
	high_mem=i++;
      else
	while (mem[i]!='\n' && mem[i]!=EOF) mem[i]=fgetc(m);
    }
  fclose(m);
  mem[high_mem+1]='0';
  mem[512]='\0';

  int prog2mem[2],mem2prog[2];
  int pid;

  if (pipe(prog2mem)<0 || pipe(mem2prog)<0)
    {
      printf("Pipe failed\n");
      return -2;
    }

  pid=fork();
  if (pid)
    {
      close(mem2prog[0]);
      close(prog2mem[1]);
      while (1)
	{
	  i=0;
	  do
	    {
	      read(prog2mem[0],(void*)&line[i++],1);
	      if (line[i-1]==13 || line[i-1]==12) line[i-1]=' ';
	    }
	  while (line[i-1]!='\n' && line[i-1]!='?');
	  line[i]='\0';
	  if (line[i-1]=='?')
	    {
	      read(prog2mem[0],(void*)&line[i++],1);
	      line[i]='\0';
	      memval[0]=mem[addr];
	      memval[1]=mem[addr+1];
	      write(mem2prog[1],(void*)&memval[0],2+cr_len);
	    }
	  if (line[0]=='*' && line[3]=='P') //Port operation
	    {
	      addr=hex2(line+33)*2;
	      if (line[38]=='O') //Output
		{
		  mem[addr]=line[45];
		  mem[addr+1]=line[46];
		  if (addr<254 && high_mem<addr+1) high_mem=addr+1;
		}
	    }
	  printf("%s",line);
	  fflush(stdout);
	  if (line[0]=='C' && line[1]=='A') //CARRY line (just before wait)
	    {
	      c='\0';
	      //while (c!='x' && c!='s' && c!='p' && c!='h' && c!='i' &&
	      //     c!='X' && c!='S' && c!='P' && c!='H' && c!='I')
	      //read(0,(void*)&c,1);
	      c='s';
	      write(mem2prog[1],(void*)&c,1);
	    }
	  if (line[0]=='A' && line[1]=='D' && hex2(line+10)==254) //FE reached
	    break;
	}
      c='x';
      write(mem2prog[1],(void*)&c,1);
      close(mem2prog[1]);
      close(prog2mem[0]);
      if (argc>3)
	m=fopen(argv[3],"w");
      else
	m=fopen("mem.out","w");
      for (addr=0;addr<=high_mem;addr+=(mem_out_width*2))
	{
	  for(i=0;i<mem_out_width*2;i++)
	    if (addr+i<=high_mem) fprintf(m,"%c",mem[addr+i]);
	  fprintf(m,"\n");
	}
      fclose(m);
      return 0;
    }
  else
    {
      close(mem2prog[1]);
      close(prog2mem[0]);
      dup2(mem2prog[0],0);
      dup2(prog2mem[1],1);
      close(mem2prog[0]);
      close(prog2mem[1]);
      char *p_argv[3];
      p_argv[0]=(char *)debugger;
      p_argv[1]=argv[1];
      p_argv[2]=NULL;
      execvp(p_argv[0],p_argv);
    }


}


int hex(char h)
{
  if (h>='0' && h<='9')
    return h-'0';
  else if (h>='a' && h<='f')
    return h-'a'+10;
  else if (h>='A' && h<='F')
    return h-'A'+10;
}

int hex2(char *h)
{
  return hex(*h)*16+hex(*(h+1)); 
}
